Subject: Re: Git User's Survey 2008 partial summary, part 3

From: "Shawn O. Pearce" <[email-masked]>
Date: Sun, 7 Sep 2008 16:47:18 -0700

Jonas Fonseca <[email-masked]> wrote:
> One thing that I am wondering about is how to best integrate the
> various git-specific traits. NetBeans already has several VCS plugins,
> many of which are derived from the same code and have been built to
> abide to the same UI design principles, and so naturally they have a
> similar "feel" to them. It seems foolish to not try and respect this
> when integrating git into the IDE space. Especially, to make it easier
> for people to try out and switch to git.

Yea, that's a big concern for any IDE implementor.  Many of the
Eclipse team providers (if not all of them?) have derived from the
CVS team provider that comes as part of the base platform.  So they
often share the same look-and-feel.  But I think Eclipse defines
less of a common VCS UI than what you are implying NetBeans does.

In Eclipse I think it is more common to define VCS custom views
(little windows/toolbars) and let the user turn on/off each view
as they see fit.
 
> One example is the question of how to enable users to work with the
> index without adding too many obscure UI elements. NetBeans VCS
> infrastructure and diff engine automatically annotates, which lines in
> the editor has been changed, modified, or deleted, and allows users to
> revert on a chunk level. While it seems very practical to extend the
> annotation bar to allow changes to be staged (I am not sure if this is
> even possible) it could end up cluttering a concept that many users
> are already very familiar with.

Yea, extending the annotation bar to show the index may actually
be useful quite useful.  If its only 15 pixels of horizontal width
lost that's actually worthwhile.  I think an older version of EGit
had something like this until I broke it.  I can't remember.

> I am curious what kind of considerations you have done on this topic
> in your work on EGit.

We've mostly ignored it.  I haven't put a lot of thought into it
because I have been focused on getting a solid JGit implementation
in place.

I do know that I really miss having an overview of what is
essentially the left side of git-gui; the staged and unstaged
(but modified) file lists.  The resource decorator is nice, but it
doesn't quite give the same flat-tree overview.

-- 
Shawn.